"""
/*
 * pyactivity.py 0.1
 * pyactivity.py for knowing which files were you working at in a determined
 * time.
 * It sorts files into sets grouped by the criterion having been used around
 * a determined time.
 * For example:
 ./egovt_and_eeurope.pdf 1047950283 ./TK-20SepCTO-99.pdf 1047950919 ./5q01-clu.pdf 1047951147 ./whitepaper_gridcomp.html 1047951471 ./new-tlds.html 1047951592
./problemast2.pdf 1048268645 ./Guia_Ejercicios-99.pdf 1048268991 ./p-2-nfs-smb.pdf 1048269212
 Those files in my home dir where changed at the same time. So I knew what I
 was doing at that point of time. 
 *
 * Copyright (C) Manuel Gutierrez Algaba,  2003 , algaba@seul.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
*/
"""

import os,dircache, stat
import cPickle
from pycluster import *
from pyconvtime2sec import *

listoffiles = None

class setofcachedfiles:
    """
    Set of cached files grouped by the date
    """
    def __init__(self, group):
        self.group = group
        self.listoffiles = []
        
class cachedfile:
    def __init__(self, lastmod, nameoffile, laststating):
        self.lastmod = lastmod
        self.nameoffile = nameoffile
        self.laststating = laststating

class pyactivity:
    def __init__(self):
        self.listofels = [] # list of objects comprising info about date of files

    def test1(self):
        v = visitfiles(self.mprint)
        v.search("./")

        
    def mprint(self,file):
        """
        -1: change time, that is, changes in the contents or in the permissions
        -2: modify time, just changes in the content
        -3: access time
        all of them are measured in seconds
        """
        print file, os.stat(file)[-1]

    def readoptions(self, listofargs ):
        if i[0] == '-f': # reads the file of cached files
            pass

    class visitedfile:
        def __init__(self, file, changetime):
            self.changetime = changetime
            self.nameoffile= file
        def __abs__(self):
            return self.changetime + 0L
        def __cmp__(self, a):
            if a. changetime < self. changetime:
                return 1
            if a. changetime > self. changetime:
                return -1
            return 0
            
        def __str__(self):
            return self.nameoffile + " "+ str (self.changetime)

    def storeforclusterize(self, file):
        self.listofels.append(self.visitedfile(file, os.stat(file)[-1]))

    def encluster(self, hours):
        v = visitfiles(self. storeforclusterize)
        v.search("./")
        sc = setcluster(convhour2sec( hours), self.listofels)
        sc. collapse()
        sc.collapsesecondly()
        sc.printclusters()
        

class  visitfiles :
    def __init__(self, processfunction):
        self.excludeddirs =[]
        self.listgroupssearch = []
        self.listexcludedwords = []
        self.processfunction= processfunction
        self.recurse = 1
        
    def getdirs(self,d):
        a= os.listdir(d)
        dircache.annotate(d, a)
        b = []
        for i in a:
            if  i.find('/') != -1:
                b+= [i]
        return b

    def getfiles(self, d):
        a= os.listdir(d)
        dircache.annotate(d, a)
        l = self.getdirs(d)
        b =[]
        for i in a:
            if i not in l:
                b += [i]
        return b    

    def processfile(self, file):
        #print os.system("(file %s  | grep ASCII) >/dev/null" % file)
        #print  os.system(" (file %s | grep -i text) >/dev/null" %file)
        self.processfunction(file)


    def search(self, d):
        print "Entering ", d
        l = self.getfiles(d)
        for i in l:
            try:
                self.processfile(d+ i)
            except:
                pass
            
        m = self.getdirs(d)
        if self.recurse:
         for i in m:
            if  os.path.islink( (d + i)[:-1]):
                continue
            
            self.search(d+i)
        

def run():
    a = getopt.getopt(sys.argv[1:], "a:b:c:d:e:f:g:h:i:j:")

    p = pyadvsearch()
    p. readoptions( a[0])
    for i in a[1]:
        p.search(i+ "/")
    
#    print getopt.getopt(sys.argv[1:], "a:b:c:d:e:f:g:h:i:j:", ["alpha=", "beta"])
#run()

pyactivity().encluster(1)  encluster receive HOURS , you can use 0.1 if you like
