
"""
/*
 * pycluster.py 0.1
 * pycluster.py A ATD which resembles 'clusters'. Used by pyactivity.
 *
 * Copyright (C) Manuel Gutierrez Algaba,  2003 algaba@seul.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
*/
"""

"""
Any element to clusterize must provide a __cmp__, an __str__ and a __str__
method to work, as:

    class visitedfile:
        def __init__(self, file, changetime):
            self.changetime = changetime
            self.nameoffile= file
        def __abs__(self):
            return self.changetime + 0L
        def __cmp__(self, a):
            if a. changetime < self. changetime:
                return 1
            if a. changetime > self. changetime:
                return -1
            return 0

"""

class elemcluster:
    def __init__(self):
        pass


class cluster:
    def __init__(self,  vlist_elems= []):
        self.list_elems = vlist_elems[:]
        
    def collapse(self):
        pass

    def __str__(self):
        a= ""
        for i in self.list_elems:
            a+= str(i) + ", "
        return a

    def append(self, i):
        self.list_elems.append(i)
        return self

    def printelements(self):
        for i in self.list_elems:
            print i,
        print 

    def __getitem__(self, i):
        return self.list_elems[i]

#    def __len__(self):         return len(self.list_elems)

    def newintheborder(self, nextcluster, radius):
        radius = radius / 2
        #print "newin",  abs(nextcluster[0]) -  abs(self[-1]), abs(nextcluster[0])
        if radius >= abs(nextcluster[0]) -  abs(self[-1]):
            a = []
            for i in self:
                if radius >= abs(abs(i) - abs(self[-1])):
                    a += [abs(i)]
            for i in nextcluster:
                if radius >= abs(i) - abs(self[-1]):
                    a += [abs(i)]
            return cluster(a)
        return None

class setcluster:
    def __init__(self, radius, listofelements):
        self.listofelements = listofelements
        self.listofelements.sort()
        self.listofclusters = []
        self.radius = radius
        
    def collapse(self):
        lastel= None
        for i in self.listofelements:
            if lastel is None:
                lastel = abs(i)
                self.listofclusters.append(cluster().append(i))
                continue
            if self.radius < abs(i) - lastel :
                #print abs(i) - lastel
                lastel = abs(i)
                self.listofclusters.append(cluster().append(i))
            else:
                self.listofclusters[-1]. append(i)
            #print self.listofclusters[-1]

    def collapsesecondly(self):
        a = []
        l = self.listofclusters
        for i in xrange(0, len(l)):
            a.append(l[i])
            try:
                new = l[i].newintheborder( l[i+1], self.radius )
                if new:
                    a.append(new)
            except IndexError:
                pass
        self.listofclusters = a

    def printclusters(self):
        for i in self.listofclusters:
            i.printelements()
        

def test():
    listofels= [4,6,8, 9, 20, 13, 15, 18 , 40, 32 ]
    sc = setcluster(4, listofels)
    sc. collapse()
    print sc. listofelements
    sc.printclusters()
    sc.collapsesecondly()
    sc.printclusters()

test()
    
